//+------------------------------------------------------------------+
//|                                               __Manual_SL_TP.mq4 |
//|                              factor  2009, vladimiromsk@mail.ru |
//|                                 http://alliancenet.dlinkddns.com |
//+------------------------------------------------------------------+
#property copyright "factor  2009, vladimiromsk@mail.ru"
#property link      "http://alliancenet.dlinkddns.com"

extern string     _1="1.  SL. 0 - , 1 - , 2 - ";
extern int        TypeSL=0;
extern string     _2="2.  SL. 0 -     ";
extern double     ValueSL=100;
extern string     _3="3.  TP. 0 - , 1 - , 2 - ";
extern int        TypeTP=0;
extern string     _4="4.  TP. 0 -     ";
extern double     ValueTP=100;

extern string     _5="5.      ";
extern int        mySleep=1000;

extern string     _6="6.   ";
extern string     _61="6.1.   BUY ";
extern color      myColorBUY=Blue;
extern string     _62="6.2.   SELL ";
extern color      myColorSELL=Red;

extern string     _7="7.      ";
extern string     _71="7.1.  SL  ";
extern color      myColorLineBUY=Yellow;
extern string     _72="7.2.  TP  ";
extern color      myColorLineSELL=Tomato;

#property show_inputs

double GetLine(string aName, double aChena, color aColor)
{
   if (ObjectFind(aName)==-1)
   {
      ObjectCreate(aName,OBJ_HLINE,0,0,aChena);
      ObjectSet(aName,OBJPROP_BACK,True);
      ObjectSet(aName,OBJPROP_COLOR,aColor);
      ObjectSet(aName,OBJPROP_STYLE,STYLE_DASHDOT);
      return(aChena);
   }else
      return(ObjectGet(aName,OBJPROP_PRICE1));
}

double GetLineST(int aTicket, double aChena)
{
   return(GetLine("SL"+aTicket,aChena,myColorLineSELL));
}

double GetLineTP(int aTicket, double aChena)
{
   return(GetLine("TP"+aTicket,aChena,myColorLineBUY));
}

int start()
{
   int TmpI;
   
   int      TmpIsBuy;
   double   fSL;
   double   fTP;
   double   TmpSL;
   double   TmpTP;
   double   TmpChenaGood;
   double   TmpChenaBad;
   color    TmpColor;
   
   int      TmpHistoryTicket=0;
   
   while (!IsStopped())
   {
      if (OrdersTotal() > 0 )
         for (TmpI=OrdersTotal()-1;TmpI>=0;TmpI--)
            if (OrderSelect(TmpI,SELECT_BY_POS))
               if(OrderSymbol()==Symbol()&&(OrderType()==OP_BUY||OrderType()==OP_SELL))
               {
                  while (True)
                  {
                     RefreshRates();
                     //     
                     if (OrderType()==OP_BUY)
                     {
                        TmpIsBuy = 1;
                        TmpChenaGood = MODE_ASK;
                        TmpChenaBad  = MODE_BID;
                        TmpColor = myColorBUY;
                     }else{
                        TmpIsBuy = -1;
                        TmpChenaGood = MODE_BID;
                        TmpChenaBad  = MODE_ASK;
                        TmpColor = myColorSELL;
                     }
                     
                     TmpSL = OrderStopLoss();
                     TmpTP = OrderTakeProfit();
                     
                     switch(TypeSL)
                     {
                        case 1 : fSL = ((AccountFreeMargin()*ValueSL)/100)/OrderLots()*Point;
                        break;
                        case 2 : fSL = ValueTP/OrderLots()*Point;
                        break;
                        default : fSL=ValueSL*Point;                       
                     }

                     switch(TypeTP)
                     {
                        case 1 : fTP = ((AccountFreeMargin()*ValueSL)/100)/OrderLots()*Point;
                        break;
                        case 2: fTP = ValueTP/OrderLots()*Point;
                        break;
                        default : fTP=ValueTP*Point;                       
                     }
                     
                     
                     //     ValueSL  SL  ,    
                     if (ValueSL > 0 && OrderStopLoss() == 0)
                     {
                        TmpSL = OrderOpenPrice() - TmpIsBuy*fSL;
                        //        
                        if (MathAbs((MarketInfo(Symbol(),TmpChenaBad) - TmpSL)/Point) < MarketInfo(Symbol(),MODE_STOPLEVEL))
                           TmpSL = OrderStopLoss();
                     }
                     
                     //     ValueTP  TP  ,    
                     if (ValueTP > 0 && OrderTakeProfit() == 0)
                     {
                        TmpTP = OrderOpenPrice() + TmpIsBuy*fTP;
                        //        
                        if (MathAbs((TmpTP-MarketInfo(Symbol(),TmpChenaGood))/Point) < MarketInfo(Symbol(),MODE_STOPLEVEL))
                           TmpTP = OrderTakeProfit();
                     }
                     
                     if (TmpTP!=OrderTakeProfit()||TmpSL!=OrderStopLoss())
                     {
                        if (OrderModify(OrderTicket(),OrderOpenPrice(),TmpSL,TmpTP,0,TmpColor))
                           break;
                     }else
                        break;
                  }
                  
                  while (True)
                  {
                     TmpSL = OrderStopLoss();
                     if (OrderStopLoss() > 0)
                     {
                        TmpSL = GetLineST(OrderTicket(),OrderStopLoss());
                        //        
                        if (MathAbs((MarketInfo(Symbol(),TmpChenaBad) - TmpSL)/Point) < MarketInfo(Symbol(),MODE_STOPLEVEL))
                           TmpSL = OrderStopLoss();
                     }
                     
                     TmpTP = OrderTakeProfit();
                     if (OrderTakeProfit() > 0)
                     {                    
                        TmpTP = GetLineTP(OrderTicket(),OrderTakeProfit());
                        //        
                        if (MathAbs((TmpTP-MarketInfo(Symbol(),TmpChenaGood))/Point) < MarketInfo(Symbol(),MODE_STOPLEVEL))
                           TmpTP = OrderTakeProfit();
                     }
                        
                     if (TmpTP!=OrderTakeProfit()||TmpSL!=OrderStopLoss())
                     {
                        if (OrderModify(OrderTicket(),OrderOpenPrice(),TmpSL,TmpTP,0,TmpColor))
                           break;
                        else
                           Sleep(mySleep);
                     }else
                        break;
                  }
                  
               }
      if (OrdersHistoryTotal() > 0 )
         for (TmpI=OrdersHistoryTotal()-1;TmpI>=0;TmpI--)
            if (OrderSelect(TmpI,SELECT_BY_POS,MODE_HISTORY))
            {
               if (OrderTicket() > TmpHistoryTicket)
                  TmpHistoryTicket = OrderTicket();
               else
                  if (OrderTicket() == TmpHistoryTicket || (TmpI+50)==OrdersHistoryTotal())
                     break;
               if (OrderSymbol()==Symbol()&&(OrderType()==OP_BUY||OrderType()==OP_SELL))
               {
                  ObjectDelete("SL"+OrderTicket());
                  ObjectDelete("TP"+OrderTicket());
               }
                  
            }
      Sleep(1000);
   }
   
      if (OrdersTotal() > 0 )
         for (TmpI=OrdersTotal()-1;TmpI>=0;TmpI--)
            if (OrderSelect(TmpI,SELECT_BY_POS))
               if (OrderSymbol()==Symbol()&&(OrderType()==OP_BUY||OrderType()==OP_SELL))
               {
                  ObjectDelete("SL"+OrderTicket());
                  ObjectDelete("TP"+OrderTicket());
               }
                  
            
   return(0);
}
//+------------------------------------------------------------------+